/*
 * Copyright (c) 1999-2001 by Sun Microsystems, Inc.
 * All rights reserved.
 */

/*
 * miipriv.h
 * MII/PHY Support for MAC drivers. private definitions for mii module
 */

#ifndef	_MIIPRIV_H
#define	_MIIPRIV_H

#pragma ident	"@(#)miipriv.h	1.1	01/08/17 SMI"

#ifdef	__cplusplus
extern "C" {
#endif

/* Vendor Specific functions */
typedef void (*phy_genfunc)(mii_handle_t, int phy);
typedef int (*phy_getspeedfunc)(mii_handle_t, int phy, int *speed, int *fd);

/* per-PHY information. */
struct phydata
{
	ulong_t id;			/* ID from MII registers 2,3	*/
	char *description;		/* Text description from ID	*/
	phy_genfunc phy_dump;		/* how to dump registers	*/
	phy_genfunc phy_postreset;	/* What to do after reset/init	*/
	phy_getspeedfunc phy_getspeed;	/* how to find current speed	*/
	unsigned short control;		/* Bits to write to control reg	*/
	enum mii_phy_state state;	/* State of link at this PHY	*/
	int fix_speed;			/* Speed fixed in conf file	*/
	int fix_duplex;			/* Duplex fixed in conf file	*/
	/*
	 * ^^NEEDSWORK: We can only fix speed for the driver, never mind a
	 * particular PHY on a particular instance, but this is where this
	 * belongs.
	 */
};

typedef struct mii_info
{
	dev_info_t *mii_devi;		/* MAC's devinfo		*/
	mii_readfunc_t mii_read;	/* How to read an MII register	*/
	mii_writefunc_t mii_write;	/* How to write an MII register	*/
	mii_linkfunc_t mii_linknotify;	/* Call when link state changes	*/
	void *mii_arg;			/* Passed to above functions	*/
	timeout_id_t portmon_timer;	/* ID of timer for port monitor	*/
	kmutex_t *lock;			/* Lock to serialise mii calls	*/
	struct phydata *phys[32];	/* PHY data indexed by address	*/
} mii_info_t;

#ifdef	__cplusplus
}
#endif

#endif	/* _MIIPRIV_H */
